<template>
  <div id="vlue-dev-create-popup-overlay" v-on:click="hideCreatePopup()">
    <div id="vlue-dev-create-popup"
      :style="getPopupPositionAndSize()"
      v-on:click="$event.stopPropagation()">
      <div id="vlue-dev-create-popup-banner">
        <div id="vlue-dev-create-popup-icon" :style="getCreatePopupIconStyle()"></div>
      </div>
      <div id="vlue-dev-create-popup-content">
        <div id="vlue-dev-create-popup-content-categories">
          <input
            type="button"
            v-for="category in categories"
            :value="category"
            :class="{ selected: selectedCategory == category }"
            v-on:click="setSelectedCategory(category)">
        </div>
        <div class="vlue-dev-create-popup-content-groups"
          :class="{ selected: selectedCategory == 'division' }">
          <div class="vlue-dev-create-popup-content-group"
            v-for="type in Object.keys(divisions)"
            v-if="typeMatchesButtonPressed(type, createPopupParams.direction)">
            <h3>{{type}}</h3>
            <input type="button"
              :value="option"
              v-if="type != 'grid'"
              v-for="option in divisions[type]"
              v-on:click="optionChosen('division', type, option)">
            <div class="vlue-dev-create-popup-grid-options" v-if="type == 'grid'">
              <span><input type="number" value="" v-model="numberOfCells"><p>cells</p></span>
              <span><input type="number" value="" v-model="pixelsPerCell"><p>px / cell</p></span>
              <span><input type="button" value="create grid"
                v-on:click="optionChosen('division', type, { numberOfCells, pixelsPerCell })">
              </span>
            </div>
          </div>
        </div>
        <div class="vlue-dev-create-popup-content-groups"
          :class="{ selected: selectedCategory == 'content' }">
          <div v-for="type in Object.keys(getContentComponents())"
            class="vlue-dev-create-popup-content-group">
            <h3></h3>
            <div class="vlue-dev-create-popup-content-icons">
              <button v-for="option in getContentComponents()[type]"
                type="button"
                :style="getContentComponentIconStyle(type, option)"
                v-on:click="optionChosen('content',  type, option)">
                <p>{{option}}</p>
              </button>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import Vue from 'vue'
import store from '../../store/store'
import { mapState } from 'vuex'

export default Vue.extend({
  computed: {
    ...mapState([
      'createPopupParams',
      'contentComponentProps',
    ])
  },
  data() {
    return {
      numberOfCells: 6,
      pixelsPerCell: 300,
      selectedCategory: '',
      categories: [
        'division',
        'content',
      ],
      divisions: {
        vertical: [
          '100px',
          '200px',
          '300px',
          '400px',
          '500px',
          '25%',
          '33%',
          '50%',
        ],
        horizontal: [
          'fit-content',
        ],
        grid: [],
      }
    }
  },
  created() {
    if (this.createPopupParams.direction == 'center') {
      // set default category to content for center button
      this.selectedCategory = 'content';
      // disable adding grid divisions on containers with content in them
      if (this.createPopupParams.current.contentComponents) this.categories.splice(0, 1);
    } else {
      // set default category to division for side buttons
      this.selectedCategory = 'division';
      // disable adding content for side buttons
      this.categories.splice(1, 1);
    }
  },
  methods: {
    setSelectedCategory(category) {
      this.selectedCategory = category;
    },
    typeMatchesButtonPressed(type, direction) {
      // filter which types of divisions to display based on button pressed
      return (('center'    ).includes(direction) && type == 'grid'      )
          || (('left right').includes(direction) && type == 'vertical'  )
          || (('up down'   ).includes(direction) && type == 'horizontal')
    },
    getContentComponents() {
      // convert from object containing objects to object containing arrays
      return Object.keys(this.contentComponentProps).reduce((acc, key) => (
        { ...acc, [key]: Object.keys(this.contentComponentProps[key]) }
      ), {});
    },
    getContentComponentIconStyle(type, option) {
      return {
        'background-image': "url('components/" + type + "/" + option + ".png')",
      }
    },
    getCreatePopupIconStyle() {
      return {
        'background-image': "url('core/images/createPopup"
          + this.createPopupParams.direction[0].toUpperCase()
          + this.createPopupParams.direction.slice(1)
          + ".png')"
      }
    },
    getPopupPositionAndSize() {
      // popup position and size
      var popup = {
        position: this.createPopupParams.clickPosition,
        space: 10,
        size: {
          width: 240,
          height: 400
        },
        constraints: undefined as (undefined | {
          left  : number,
          top   : number,
          right : number,
          bottom: number,
        }),
      };
      // popup positional constraints based on viewport
      popup.constraints = {
        left:                        (popup.size.width  / 2) + popup.space,
        top:                         (popup.size.height / 2) + popup.space,
        right:  window.innerWidth  - (popup.size.width  / 2) - popup.space,
        bottom: window.innerHeight - (popup.size.height / 2) - popup.space
      };
      // apply positional constraints
      if(popup.position.x < popup.constraints.left)   popup.position.x = popup.constraints.left;
      if(popup.position.x > popup.constraints.right)  popup.position.x = popup.constraints.right;
      if(popup.position.y < popup.constraints.top)    popup.position.y = popup.constraints.top;
      if(popup.position.y > popup.constraints.bottom) popup.position.y = popup.constraints.bottom;
      // return popup position and size as px values
      return {
        width:  popup.size.width  + 'px',
        height: popup.size.height + 'px',
        left:   popup.position.x  + 'px',
        top:    popup.position.y  + 'px'
      }
    },
    optionChosen(category, type, option) {
      // check category
      category == 'division'
        // category is division, check type
        ? type == 'grid'
          // type is grid
          ? store.dispatch('changeWebsiteState', {
            mutation: 'addGridContainers',
            params: { ...this.createPopupParams, grid: option },
          })
          // type is vertical or horizontal
          : store.dispatch('changeWebsiteState', {
            mutation: 'addContainer',
            params: { ...this.createPopupParams, size: option },
          })
        // category is content
        : store.dispatch('changeWebsiteState', {
          mutation: 'addContentComponent',
          params:   { ...this.createPopupParams, name: option, folder: type },
        });
      // close popup
      this.hideCreatePopup();
    },
    hideCreatePopup() {
      store.commit('hideCreatePopup');
    }
  }
})
</script>

<style lang="scss">
  @import "../../style/vars.scss";

  #vlue-dev-create-popup-overlay {
    position: fixed;
    top: 0;
    left: 0;
    right: 0;
    bottom: 0;
    z-index: 1000;
    #vlue-dev-create-popup {
      position: absolute;
      background: white;
      transform: translate(-50%,-50%);
      z-index: 1000;
      padding: 0;
      border-radius: 5px;
      box-shadow: 0 10px 10px rgba(0,0,0,0.1);
      animation: $vlue-transition-duration appear ease-out;
      overflow: hidden;
      #vlue-dev-create-popup-banner {
        height: 70px;
        background-color: $vlue-color-create;
        background-image: url('../../../public/core/images/stripePattern.png');
        background-size: 30px;
        margin: -10px;
        position: relative;
        z-index: 1002;
        #vlue-dev-create-popup-icon {
          position: absolute;
          left: 50%;
          top: 100%;
          transform: translate(-50%,-50%);
          width: 80px;
          height: 80px;
          background: $vlue-website-default-bg-color;
          border-radius: 50%;
          background-size: cover;
        }
      }
      #vlue-dev-create-popup-content {
        margin: -20px 0;
        height: 360px;
        input {
          color: black;
          background: hsl(67, 54%, 84%);
          margin: 0;
        }
        #vlue-dev-create-popup-content-categories {
          display: flex;
          box-shadow: 0 5px 5px rgba(0,0,0,0.1);
          z-index: 1001;
          position: relative;
          input {
            flex: 25%;
            flex-grow: 0;
            border: none;
            font-size: 14px;
            padding: 70px 10px 10px;
            transition: $vlue-transition-duration;
            &:hover {
              background: white;
            }
            &.selected {
              flex-grow: 1;
              background: hsl(60, 56%, 91%);
            }
          }
        }
        .vlue-dev-create-popup-content-groups {
          height: 265px;
          overflow-y: auto;
          position: absolute;
          transition: $vlue-transition-duration;
          width: 100%;
          background: white;
          &:nth-of-type(2) {
            left: -100%;
            width: calc(100% + 100px);
          }
          &:nth-of-type(3) {
            right: calc(-100% - 17px);
          }
          &.selected {
            &:nth-of-type(2) {
              left: 0;
              width: 100%;
            }
            &:nth-of-type(3) {
              right: 0;
            }
          }
          .vlue-dev-create-popup-content-group {
            &:last-child {
              margin-bottom: 50px;
            }
            .vlue-dev-create-popup-content-icons {
              display: flex;
              flex-wrap: wrap;
              button {
                width: 46px;
                height: 46px;
                margin: 0 0 8px 8px;
                position: relative;
                padding: 0;
                border: none;
                border-radius: 5px;
                transition: $vlue-transition-duration;
                background-size: 40px;
                background-position: center;
                background-color: $vlue-color-create;
                top: 0;
                &:nth-child(4n) p {
                  left: unset;
                  right: 0;
                  transform: none;
                }
                &:nth-child(4n + 1) p {
                  left: 0;
                  transform: none;
                }
                &:hover {
                  padding: 0;
                  background-size: 40px;
                  background-position: center;
                  background-color: #333;
                  top: -4px;
                  box-shadow: 0 5px 4px #0005;
                  p {
                    opacity: 1;
                    top: 52px;
                    box-shadow: 0 5px 4px #0005;
                  }
                }
                p {
                  position: absolute;
                  top: 60px;
                  left: 50%;
                  transform: translateX(-50%);
                  transition: $vlue-transition-duration;
                  z-index: 1;
                  opacity: 0;
                  pointer-events: none;
                  background: #333;
                  color: white;
                  padding: 10px 30px;
                  border-radius: 5px;
                }
              }
            }
            .vlue-dev-create-popup-grid-options {
              width: 240px;
            }
            h3 {
              color: black;
              font-size: 16px;
              padding: 10px 20px;
              background: hsl(67, 38%, 77%);
              text-align: center;
              margin: 0 0 10px;
            }
            span input, p {
              display: inline-block;
            }
            input {
              padding: 14.5px 20px;
              margin: 0 10px 10px;
              border-radius: 5px;
              border: none;
              display: block;
              transition: $vlue-transition-duration;
              &[type=button]:hover {
                background: hsl(67, 38%, 77%);
                padding-left: 30px;
              }
              &[type=number] {
                width: 50px;
                &::-webkit-inner-spin-button,
                &::-webkit-outer-spin-button {
                  -webkit-appearance: none;
                  margin: 0;
                }
              }
            }
          }
        }
      }
    }
  }
  @keyframes appear {
    from {
      opacity: 0;
      padding: 10px;
    }
    to {
      opacity: 1;
      padding: 0;
    }
  }
</style>
